/// This module contains the struct Scene.
pub mod scene;

/// This module contains everything related to characters, playable or enemies.
pub mod character;

/// This module contains everything related to the controls of the game.
pub mod controls;

/// This module helps us dealing with textures.
pub mod texture;

/// This module helps us dealing with fonts.
pub mod font;

/// This module contains the math tools that will be used.
pub mod math;

/// This module contains our wrapper of SFML window.
pub mod renderer;

/// This module contains everything related to physics.
pub mod physics;

/// This module contains the map structure.
pub mod map;
